/*
@copyright(disclaimer)

Licensed Materials - Property of IBM
IBM DB2 Content Manager Enterprise Edition V8  (program number 5724-B19)
IBM DB2 Content Manager Express Edition V8 (program number 5724-F73)
IBM DB2 Content Manager for z/OS V8 (program number 5697-H60)
(c ) Copyright IBM Corp. 2005. All Rights Reserved.

US Government Users Restricted Rights
Use, duplication or disclosure restricted by GSA ADP Schedule
Contract with IBM Corp.

DISCLAIMER OF WARRANTIES :

Permission is granted to copy and modify this  Sample code, and to
distribute modified versions provided that both the copyright
notice,- and this permission notice and warranty disclaimer  appear in all copies and modified
versions.

THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.
IBM  AND ITS SUPPLIERS AND LICENSORS  DISCLAIM
ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY
OF NON-INFRINGEMENT AND THE IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
PARTICULAR PURPOSE. IN NO EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY
DAMAGES ARISING OUT OF THE USE OF  OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF
THE SAMPLE CODE, OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL
IBM OR ITS LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA,
OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS LICENSORS OR SUPPLIERS
HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

@endCopyright
*/

package com.ibm.bpe.cm.sca;

import com.ibm.bpe.cm.CMBPCConstants;
import com.ibm.bpe.cm.api.CMBPCIntegration;
import com.ibm.bpe.cm.util.CollectionPointCallbackInfo;
import com.ibm.websphere.sca.ServiceCallback;
import com.ibm.websphere.sca.ServiceImplAsync;
import com.ibm.websphere.sca.ServiceManager;
import com.ibm.websphere.sca.Ticket;
import commonj.sdo.DataObject;

/**
 * Implementation of the SCA component CollectionPointService providing the following operations:
 * 
 * collectionPoint (implemented by invokeAsync)
 * 
 */
public class CollectionPointServiceImpl implements ServiceImplAsync {
	/**
	 * Default constructor.
	 */
	public CollectionPointServiceImpl() {
		super();
	}

	/**
	 * Return a reference to the component service instance for this implementation
	 * class.  This method should be used when passing this service to a partner reference
	 * or if you want to invoke this component service asynchronously.    
	 *
	 * @generated (com.ibm.wbit.java)
	 */
	private Object getMyService() {
		return (Object) ServiceManager.INSTANCE.locateService("self");
	}
	
	/*
	 * This method is called when the collectionPoint operation is issued.
	 * 
	 * @see com.ibm.websphere.sca.ServiceImplAsync#invokeAsync(com.ibm.websphere.sca.scdl.OperationType, java.lang.Object, com.ibm.websphere.sca.ServiceCallback, com.ibm.websphere.sca.Ticket)
	 */
	
	public void invokeAsync(com.ibm.websphere.sca.scdl.OperationType operationType,
            java.lang.Object dataObject,
            ServiceCallback serviceCallback,
            Ticket ticket)
	{
		//
		// This function should only be called for the collection point
		// implementation,
		// but to be sure, compare the operation name
		//
		if (operationType.getName().equals(CMBPCConstants.COLLECTIONPOINT_OPERATION)) {
			
			// collect both the service callback as well as the ticket in a
			// callback class
			
			CollectionPointCallbackInfo callbackInfo = new CollectionPointCallbackInfo(serviceCallback, ticket);
			// extract collection point information from the data object
			CMBPCIntegration.collectionPoint( callbackInfo, (commonj.sdo.DataObject) dataObject);
		}
	}

	/**
	 * Method generated to support implemention of operation "collectionPoint" defined for WSDL port type 
	 * named "interface.CollectionPointService".
	 * 
	 * The presence of commonj.sdo.DataObject as the return type and/or as a parameter 
	 * type conveys that its a complex type. Please refer to the WSDL Definition for more information 
	 * on the type of input, output and fault(s).
	 */
	public Integer collectionPoint(DataObject itemRef, DataObject condition,
			Integer timeoutSeconds) {
		// not implemented, overriden by invoke Async
		return null;
	}

}