/*
@copyright(disclaimer)

Licensed Materials - Property of IBM
IBM DB2 Content Manager Enterprise Edition V8  (program number 5724-B19)
IBM DB2 Content Manager Express Edition V8 (program number 5724-F73)
IBM DB2 Content Manager for z/OS V8 (program number 5697-H60)
(c ) Copyright IBM Corp. 2005. All Rights Reserved.

US Government Users Restricted Rights
Use, duplication or disclosure restricted by GSA ADP Schedule
Contract with IBM Corp.

DISCLAIMER OF WARRANTIES :

Permission is granted to copy and modify this  Sample code, and to
distribute modified versions provided that both the copyright
notice,- and this permission notice and warranty disclaimer  appear in all copies and modified
versions.

THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.
IBM  AND ITS SUPPLIERS AND LICENSORS  DISCLAIM
ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY
OF NON-INFRINGEMENT AND THE IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
PARTICULAR PURPOSE. IN NO EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY
DAMAGES ARISING OUT OF THE USE OF  OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF
THE SAMPLE CODE, OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL
IBM OR ITS LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA,
OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS LICENSORS OR SUPPLIERS
HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

@endCopyright
*/

package com.ibm.bpe.cm.ejb;

import javax.sql.DataSource;

import com.ibm.bpe.api.BusinessFlowManagerHome;
import com.ibm.bpe.cm.util.AsyncBeanWork;
import com.ibm.bpe.cm.util.CollectionPoint;
import com.ibm.bpe.cm.util.ContentEventHandling;
import com.ibm.bpe.cm.util.IntegrationException;

/**
 * Bean implementation class for Enterprise Bean: ContentManagerIntegrationStartup
 */
public class CMBPCIntegrationStartupBean
	implements javax.ejb.SessionBean
{
	private javax.ejb.SessionContext mySessionCtx;
	/**
	 * getSessionContext
	 */
	public javax.ejb.SessionContext getSessionContext()
	{
		return mySessionCtx;
	}
	/**
	 * setSessionContext
	 */
	public void setSessionContext(javax.ejb.SessionContext ctx)
	{
		mySessionCtx = ctx;
	}
	/**
	 * ejbCreate
	 */
	public void ejbCreate() throws javax.ejb.CreateException
	{
	}
	/**
	 * ejbActivate
	 */
	public void ejbActivate()
	{
	}
	/**
	 * ejbPassivate
	 */
	public void ejbPassivate()
	{
	}
	/**
	 * ejbRemove
	 */
	public void ejbRemove()
	{
	}
	
	/**
	 * start the CMBPCIntegration services
	 * @return true if they started successfully
	 */
	public boolean start()
		{
			System.out.println(">> CMBPCIntegration services started.");
			try {
				javax.naming.InitialContext ic = new javax.naming.InitialContext();
				Object obj = ic.lookup(AsyncBeanWork.BFM_HOME_REF);
				BusinessFlowManagerHome bfmHome = (BusinessFlowManagerHome)javax.rmi.PortableRemoteObject.narrow(obj, BusinessFlowManagerHome.class);
				DataSource bpedbDataSource = (DataSource) ic.lookup(AsyncBeanWork.BPEDB_DS_REF);
				DataSource lsDataSource = (DataSource) ic.lookup(AsyncBeanWork.ICMNLSDB_DS_REF);
				ContentEventHandling ceh = new ContentEventHandling(bpedbDataSource, lsDataSource, bfmHome);
				ceh.createDatabaseTable();
				CollectionPoint cp = new CollectionPoint(lsDataSource);
				cp.createDatabaseTable();
				AsyncBeanWork.initAsyncBeanWork(ic, ceh, cp);
			}
			catch (Exception e) {
				throw new IntegrationException(e);
			}
			return true;
		}

	/**
	 * stop the CMBPCIntegration services
	 *
	 */
		public void stop()
		{
			AsyncBeanWork.stopRunning();
			System.out.println(">> CMBPCIntegration services stopped.");
		}	
}
