/*
@copyright(disclaimer)

Licensed Materials - Property of IBM
IBM DB2 Content Manager Enterprise Edition V8  (program number 5724-B19)
IBM DB2 Content Manager Express Edition V8 (program number 5724-F73)
IBM DB2 Content Manager for z/OS V8 (program number 5697-H60)
(c ) Copyright IBM Corp. 2005. All Rights Reserved.

US Government Users Restricted Rights
Use, duplication or disclosure restricted by GSA ADP Schedule
Contract with IBM Corp.

DISCLAIMER OF WARRANTIES :

Permission is granted to copy and modify this  Sample code, and to
distribute modified versions provided that both the copyright
notice,- and this permission notice and warranty disclaimer  appear in all copies and modified
versions.

THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.
IBM  AND ITS SUPPLIERS AND LICENSORS  DISCLAIM
ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY
OF NON-INFRINGEMENT AND THE IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
PARTICULAR PURPOSE. IN NO EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY
DAMAGES ARISING OUT OF THE USE OF  OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF
THE SAMPLE CODE, OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL
IBM OR ITS LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA,
OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS LICENSORS OR SUPPLIERS
HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

@endCopyright
*/

package com.ibm.bpe.cm;

/**
 * Constants for the CM/WPS Integration Quick Start
 */

 public interface CMBPCConstants {
	
	/**
	 * References
	 */
	
	final static public String BFM_HOME_REF			 = "java:comp/env/ejb/BusinessFlowManagerHome";
	final static public String HTM_HOME_REF			 = "java:comp/env/ejb/HumanTaskManagerHome";
	final static public String LOCAL_BMF_HOME_REF 	 = "local:ejb/com/ibm/bpe/api/BusinessFlowManagerHome";
	final static public String BPEDB_DS_REF			 = "java:comp/env/jdbc/BPEDB";
//	final static public String ICMNLSDB_DS_REF		 = "java:comp/env/jdbc/ICMNLSDB";
	final static public String ICMNLSDB_DS_REF		= "jdbc/ICMNLSDB";
	final static public String WORK_MANAGER_REF 	 = "wm/default";
	final static public String EXTENSION_HELPER_REF  = "services:websphere/ExtensionHelper";
	final static public String CMBPC_INTEGRATION_REF = "java:comp/env/ejb/CMBPCIntegrationHome";
	
	/**
	 *  Name spaces
	 */
	
	final static public String LIB_NAMESPACE  = "http://CMBPCIntegrationLibrary/com/ibm/bpe/cm";
	final static public String CMSERVICES_NAMESPACE = LIB_NAMESPACE;
	final static public String CMCOLLECTIONPOINTSERVICE_NAMESPACE = LIB_NAMESPACE + "/CollectionPointService";

	/**
	 *  Operations
	 */
	
	final static public String COLLECTIONPOINT_OPERATION = "collectionPoint";
	
	/**
	 * Business objects and attributes
	 */ 

	final static public String BO_QUERY_RESULT_SET_ROW 				= "QueryResultSetRow";
	final static public String BOATT_QUERY_RESULT_SET_ROW_COLUMNS 	= "columns";	
	final static public String BOATT_QUERY_RESULT_SET_ROW_ROWS 		= "rows";	
	
	final static public String BO_ATTRIBUTE_VALUE 					= "AttributeValue";
	final static public String BOATT_ATTRIBUTE_VALUE_VALUE 			= "value";

	final static public String BO_ATTRIBUTE_VALUES 					= "AttributeValues";
	final static public String BOATT_ATTRIBUTE_VALUES_VALUES 		= "values";
	
	final static public String BO_ITEM_REF 							= "ItemRef";
	final static public String BOATT_ITEM_REF_PIDSTRING 			= "pidString";
	
	final static public String BO_ATTRIBUTE_SPECS 					= "AttributeSpecs";
	final static public String BOATT_ATTRIBUTE_SPECS_SPECS 			= "specs";
	
	final static public String BOATT_PROCESS_INTERFACE_ITEMID 		= "itemId";
	final static public String BOATT_PROCESS_INTERFACE_COMPONENTID 	= "componentId";
	final static public String BOATT_PROCESS_INTERFACE_VERSIONNO 	= "versionNo";
	
	final static public String BO_COLLECTION_POINT_REQUEST 						= "CollectionPointRequest";
	final static public String BOATT_COLLECTION_POINT_REQUEST_ITEMREF 			= "itemRef";
	final static public String BOATT_COLLECTION_POINT_REQUEST_TIMEOUT 			= "timeoutSeconds";
	final static public String BOATT_COLLECTION_POINT_REQUEST_CONDITION 		= "condition";
	final static public String BOATT_COLLECTION_POINT_REQUEST_CONDITION_RI 		= "requiredItems";
	final static public String BOATT_COLLECTION_POINT_REQUEST_CONDITION_RI_ITEMTYPE 		= "itemType";
	final static public String BOATT_COLLECTION_POINT_REQUEST_CONDITION_RI_ITEMQUANTITY 	= "itemQuantity";

	final static public String BO_QUERYRESULTSET						= "QueryResultSet";
	final static public String BOATT_COLLECTIONPOINT_RESPONSE  			= "collectionPointResponse";
	final static public String BOATT_COLLECTIONPOINT_RESPONSE_RESULT 	= "result";
	
	final static public String BOATT_TASK_RESPONSE						 = "response";
	
	/**
	 *  SCA Service locator
	 */
	
	final static public String BO_FACTORY = "com/ibm/websphere/bo/BOFactory";
	
	/**
	 *  Return values for the Collection Point Service:
	 * 
	 * COLLECTIONPOINT_OK           ... the condition is satisfied and processing ended regularly.
	 * COLLECTIONPOINT_ERROR        ... an error occurred during collection point processing.
	 * COLLECTIONPOINT_TIMEOUT      ... the specified timeout is reached.
	 * COLLECTIONPOINT_ITEM_DELETED ... the associated item has been deleted.
	 * 
	 */
	final static public int COLLECTIONPOINT_OK           = 0;  // The condition is satisfied and processing ended regularly.
	final static public int COLLECTIONPOINT_ERROR        = -1; // An error occurred during collection point processing.
	final static public int COLLECTIONPOINT_TIMEOUT      = 1;  // The specified timeout is reached.
	final static public int COLLECTIONPOINT_ITEM_DELETED = 2;  // The associated item has been deleted. 
	

	/**
	 * In a combined query xPath expression, this substitution parameter string will 
	 * be replaced by a clause like (id1,id2,id3) to correlate the content
	 * with the itemId routed through the flow. 
	 */
	 final static public String ITEM_LIST = "%ITEM_LIST_%";

	/**
	 * In a combined query xPath expression, this substitution parameter string will 
	 * be replaced by a clause like @ITEMID IN (...,...,...) to correlate the content
	 * with the itemId routed through the flow. 
	 */
	final static public String ITEM_LIST_PREDICATE = "%ITEM_LIST_PREDICATE%";

	/**
	 *  Predefined content attributes for content event handling
	 */

	final static public String CREATE_TRIGGER = "WF_OnCreate";
	final static public String DELETE_TRIGGER = "WF_OnDelete";


	/**
	 * Name of the custom process property to store the associated itemPid string.
	 */
	final static public String PROCESS_PROPERTY_ITEMPID = "itemPid";

	/**
	 * Name of the custom process property to store the associated itemId string.
	 */
	final static public String PROCESS_PROPERTY_ITEMID = "itemId";

	/**
	 * Name of the custom process property to store the associated componentId string.
		 */
	final static public String PROCESS_PROPERTY_COMPONENTID = "componentId";

	/**
	 * Name of the custom process property to store the associated versionId string.
	 */
	final static public String PROCESS_PROPERTY_VERSIONNUMBER = "versionNumber";

	/**
	 * Name of the custom process property to store the associated itemType string.
	 */
	final static public String PROCESS_PROPERTY_ITEMTYPE = "itemType";

	/**
	 * Name of XPath query expression Item ID substitutable parameters
	 */
	final static public String SUBSTITUTABLE_PARAMETER_ITEMID = "%" + PROCESS_PROPERTY_ITEMID.toUpperCase() + "%";

	/**
	 * Name of XPath query expression Component ID substitutable parameters
	 */
	final static public String SUBSTITUTABLE_PARAMETER_COMPONENTID = "%" + PROCESS_PROPERTY_COMPONENTID.toUpperCase() + "%";

	/**
	 * Name of XPath query expression Version ID substitutable parameters
	 */
	final static public String SUBSTITUTABLE_PARAMETER_VERSIONNUMBER = "%" + PROCESS_PROPERTY_VERSIONNUMBER.toUpperCase() + "%";

	/**
	 * Name of XPath query expression Item Type ID substitutable parameters
	 */
	final static public String SUBSTITUTABLE_PARAMETER_ITEMTYPE = "%" + PROCESS_PROPERTY_ITEMTYPE.toUpperCase() + "%";

}
