/*
@copyright(disclaimer) 
Licensed Materials - Property of IBM
IBM DB2 Content Manager Enterprise Edition V8  (program number 5724-B19)
IBM DB2 Content Manager Express Edition V8 (program number 5724-F73)
IBM DB2 Content Manager for z/OS V8 (program number 5697-H60)
(c ) Copyright IBM Corp. 1994,  2005. All Rights Reserved.

US Government Users Restricted Rights                                  
Use, duplication or disclosure restricted by GSA ADP Schedule          
Contract with IBM Corp.     

DISCLAIMER OF WARRANTIES :                                             
                                                                       
Permission is granted to copy and modify this  Sample code, and to           
distribute modified versions provided that both the copyright        
notice, and this permission notice and warranty disclaimer  appear in all copies and modified  
versions. 

This software is provided "AS IS."  IBM and its Suppliers and Licensors expressly disclaim all
warranties, whether  EXPRESS OR IMPLIED,  INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE OR WARRANTY OF  NON-INFRINGEMENT.  IBM AND ITS SUPPLIERS AND
LICENSORS SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE THAT RESULT FROM USE OR
DISTRIBUTION OF THE SOFTWARE OR THE COMBINATION OF THE SOFTWARE WITH ANY OTHER CODE.
IN NO EVENT WILL IBM OR ITS SUPPLIERS  AND LICENSORS BE LIABLE FOR ANY LOST REVENUE, PROFIT OR
DATA, OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF OR INABILITY TO USE
SOFTWARE, EVEN IF IBM HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.                          
                                                                 
@endCopyright     
*/

package com.ibm.bpe.cm.servlets;
import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.ibm.bpe.cm.utils.Helpers;
import com.ibm.mm.beans.CMBDataManagement;

/**
* This servlet deletes the annotation specified by the parameters ITEMPID and contentIndex.
* In case of an error it sets the response status to HttpServletResponse.SC_INTERNAL_SERVER_ERROR.
*/

public class DeleteAnnotationServlet extends HttpServlet {

	public void doGet(HttpServletRequest request,
					  HttpServletResponse response)	throws ServletException, IOException {
		doPost(request, response);
	}

	public void doPost(HttpServletRequest request,
					   HttpServletResponse response) throws ServletException, IOException {
		CMBDataManagement dataMgmt = null;

		try {
			// get the itemPid for the item to be updated
			String itemPid = request.getParameter("ITEMPID");
			// get the content index for the document part the annotation of which should be updated
			int contentIndex = (new Integer(request.getParameter("contentIndex"))).intValue();

			// initialize CMBDataManagement object for the item to be updated
			dataMgmt = Helpers.setupDataBean(request, itemPid, true);

			// check out, delete the annotation and check the item back in
			if (dataMgmt.isCheckedOut()) try { dataMgmt.checkIn(); } catch (Exception e) {}  // try if you can check it in before
			dataMgmt.checkOut();
			dataMgmt.deleteAnnotation(contentIndex);
			dataMgmt.checkIn();
		}
		catch (Exception e) {
			e.printStackTrace();
			// there was a problem, send error and commit the response
			response.sendError(HttpServletResponse.SC_EXPECTATION_FAILED);

		}
	}

} // DeleteAnnotationServlet
