/*
@copyright(disclaimer) 
Licensed Materials - Property of IBM
IBM DB2 Content Manager Enterprise Edition V8  (program number 5724-B19)
IBM DB2 Content Manager Express Edition V8 (program number 5724-F73)
IBM DB2 Content Manager for z/OS V8 (program number 5697-H60)
(c ) Copyright IBM Corp. 1994,  2005. All Rights Reserved.

US Government Users Restricted Rights                                  
Use, duplication or disclosure restricted by GSA ADP Schedule          
Contract with IBM Corp.     

DISCLAIMER OF WARRANTIES :                                             
                                                                       
Permission is granted to copy and modify this  Sample code, and to           
distribute modified versions provided that both the copyright        
notice, and this permission notice and warranty disclaimer  appear in all copies and modified  
versions. 

This software is provided "AS IS."  IBM and its Suppliers and Licensors expressly disclaim all
warranties, whether  EXPRESS OR IMPLIED,  INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE OR WARRANTY OF  NON-INFRINGEMENT.  IBM AND ITS SUPPLIERS AND
LICENSORS SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE THAT RESULT FROM USE OR
DISTRIBUTION OF THE SOFTWARE OR THE COMBINATION OF THE SOFTWARE WITH ANY OTHER CODE.
IN NO EVENT WILL IBM OR ITS SUPPLIERS  AND LICENSORS BE LIABLE FOR ANY LOST REVENUE, PROFIT OR
DATA, OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF OR INABILITY TO USE
SOFTWARE, EVEN IF IBM HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.                          
                                                                 
@endCopyright     
*/

package com.ibm.bpe.cm.servlets;
import java.io.IOException;

import javax.servlet.Servlet;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.ibm.bpe.cm.utils.Helpers;
import com.ibm.mm.beans.CMBDataManagement;

/**
* This servlet deletes a part specified by the 'deleteCI' content index from the item specified by the ITEMPID parameter.
*/


public class DeletePartServlet extends HttpServlet implements Servlet {

	public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		doPost(request, response);
	}

	public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		String errorTarget = null;   // in case of error this is set to an URL to forward the request to
		String itemPid = request.getParameter("ITEMPID");

		try	{
		  	String deleteContentIndex = request.getParameter("deleteCI");
	  		CMBDataManagement dataMgmt = Helpers.setupDataBean(request, itemPid, true);
			if (dataMgmt.isCheckedOut()) try { dataMgmt.checkIn(); } catch (Exception e) {}
			if (dataMgmt.isCheckedOut())
				errorTarget = "updateAttributes.jsp?&msg=locked";
			else {
				dataMgmt.checkOut();
				int deleteIndex = Integer.parseInt(deleteContentIndex);
				// Delete the part identified by the 'deleteCI' parameter.
				// Note that the authorization need not be checked here since this action can only be performed if the user
				// is authorized (otherwise the link that triggers this servlet will not be available in the actions column.
				dataMgmt.deleteContent(deleteIndex); 
				dataMgmt.checkIn();
				System.out.println("-> Part deleted");
			}
		}
		catch (Exception e) {
			e.printStackTrace();
			errorTarget = "error.jsp";
		}

		if (errorTarget == null)
			response.sendRedirect("updateAttributes.jsp?TKIID=" + request.getParameter("TKIID") +
	   											       "&PIPID=" + request.getParameter("PIPID") +
												       "&ITEMPID=" + itemPid);
		else
			request.getRequestDispatcher(errorTarget).forward(request, response);
	}
 
} // DeletePartServlet
