<%--  
@copyright(disclaimer) 
Licensed Materials - Property of IBM
IBM DB2 Content Manager Enterprise Edition V8  (program number 5724-B19)
IBM DB2 Content Manager Express Edition V8 (program number 5724-F73)
IBM DB2 Content Manager for z/OS V8 (program number 5697-H60)
(c ) Copyright IBM Corp. 1994,  2005. All Rights Reserved.

US Government Users Restricted Rights                                  
Use, duplication or disclosure restricted by GSA ADP Schedule          
Contract with IBM Corp.     

DISCLAIMER OF WARRANTIES :                                         
   
Permission is granted to copy and modify this Sample code, and to           
distribute modified versions provided that both the copyright        
notice, and this permission notice and warranty disclaimer  appear in all copies and modified  
versions. 

This software is provided "AS IS."  IBM and its Suppliers and Licensors expressly disclaim all
warranties, whether  EXPRESS OR IMPLIED,  INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE OR WARRANTY OF  NON-INFRINGEMENT.  IBM AND ITS SUPPLIERS AND
LICENSORS SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE THAT RESULT FROM USE OR
DISTRIBUTION OF THE SOFTWARE OR THE COMBINATION OF THE SOFTWARE WITH ANY OTHER CODE.
IN NO EVENT WILL IBM OR ITS SUPPLIERS  AND LICENSORS BE LIABLE FOR ANY LOST REVENUE, PROFIT OR
DATA, OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF OR INABILITY TO USE
SOFTWARE, EVEN IF IBM HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.     
                                                                 
@endCopyright
--%>

<%-- This JSP implements the general header that is included by all pages of the Quick Start Client.
	 It looks up some global parameters and makes them available to the enclosing JSPs.
	 Note that it contains the page definition and parts of the HTML design. These have been removed from the original
	 JSPs to reduce redundancy since the are almost always the same. Any JSP that includes this header needs to add
	 the two HTML end tags </BODY></HTML> individually. If this is not considered good practice, the content of this
	 file can be added to the individual JSPs using cut&paste.
	 
	 If the content of this file is changed, all JSPs including it need to be modified to enforce recompilation.
	 Otherwise the change will not be present in the corresponding servlets.
--%>

<%-- general page definition used by all JSPs. error.jsp and startProcessInstances.jsp overwrite this by their individual
     page import statements
--%>

<%-- The header extracts some global parameters from the request that are required for breadcrumb navigation and
	 also used by the Java code within the JSPs that include this header. Note that each JSP may use a specific
	 subset of these. If a parameter is not available, the corresponding value is set to an empty string which supports
	 concatenation to obtain new URLs (to avaoid that a parameter value evaluates to the string 'null').
--%>

<%
	// specific portion of title text to be embedded within <TITLE></TITLE> tags
	String title = (String)request.getAttribute("title"); 
	
	// user currently logged on for display in the 'userID' section of the menu
	String userId = (String)session.getAttribute("UserId");
	if (userId == null) {
		userId =(String)request.getParameter("userId");
		if (userId != null) session.setAttribute("UserId", userId);
	}

	// fetch the value of the work list ID parameter and store it in a session attribute
	// if a work list ID is not explicitly set it defaults to 0
	String workListId = request.getParameter("WLID");
    if (workListId == null) {
		workListId = (String)session.getAttribute("WLID");	
	}
	else {
	    session.setAttribute("WLID", workListId);
	}
	int wlId = (workListId == null) ? 0 : (new Integer(workListId)).intValue();

	// fetch the activity instance id required when dealing with an activity
	String tkiidString = request.getParameter("TKIID");
	if (tkiidString == null) tkiidString = "";

	// fetch the PID of the item that is routed through the process in both encoded and unencoded form
	String processItemPid = request.getParameter("PIPID");
	String encodedProcessItemPid	= "";
	String itemPid = request.getParameter("ITEMPID");
	String encodedItemPid = "";
	try {
		if (processItemPid == null)
			processItemPid = "";
		else
			encodedProcessItemPid = java.net.URLEncoder.encode(processItemPid, "UTF8");
	
		if (itemPid == null)
			itemPid = "";
		else
			encodedItemPid = java.net.URLEncoder.encode(itemPid, "UTF8");
	}
	catch (java.io.UnsupportedEncodingException uee) {
	}

	// error message to be displayed in the menu
	String msg				= request.getParameter("msg");

	// *************************** this code can be used for diagnostic purposes *********************************
	// Print class name and list of parameters when activating a JSP
	//
	// System.out.println("## Class: " + this.getClass().getName());
	// Enumeration enumeration = request.getParameterNames();
	// String key, value;
	// while (enumeration.hasMoreElements()) {
	//	  key = (String)enumeration.nextElement();
	//	  System.out.println("## " + key + " = " + (String)request.getParameter(key));
	// }
	// **************************** end of code for diagnostic purposes *******************************************
%>

<%-- General HTML header used by all client JSPs. Note that 'charset' is 'UTF-8' to enable use with different languages.
--%>

<TABLE border="0" cellpadding="0" cellspacing="0" width="100%" 
       style="background-image: url('images/background.gif'); background-repeat:no-repeat;background-color:#ADB0EC;
	    border-top: 1px solid #000000; border-bottom: 1px solid #000000">

	<%-- Banner --%>
	<TR>
	    <TD align="left"><IMG src="images/clientLogo.gif" width="320" height="25" alt='Client Logo'></TD>
	    <TD colspan="2" align="right"><IMG src="images/productLogo.gif" width="500" height="25" alt='Product Logo'></TD>
	</TR>
	

	<%-- Menu bar: breadcrumb navigation section --%>

	<TR>
	    <TD class="top-navigation" align="left">
<%  if (request.getParameter("menu") == null) {  // if the parameter 'menu=no' is present, no menu bar is displayed
%>	
			<A href="help.jsp?menu=no" class="top-nav-item" target="_blank">Help</A>
			&nbsp; &nbsp; &nbsp;
<%			if (request.getParameter("WLID") != null) { // display "My ToDos" entry in breadcrumb only, if work list ID is present
%>  
				<A href="listWorkItems.jsp?WLID=<%=workListId%>" class="top-nav-item">Refresh</A>
<%			}
			else if (tkiidString.length() > 0) {
%>  
				<A href="listWorkItems.jsp?WLID=<%=workListId%>" class="top-nav-item">My ToDos</A>
<%			}
			if (itemPid.length() > 0 || request.getParameter("mode") != null) { // display "Work Item" entry in breadcrumb only, if itemPid is present
				if (tkiidString.length() > 0) {   								// display "Create Item" if mode=nocreate
%>
					&gt;
					<A href="showWorkItem.jsp?TKIID=<%=tkiidString%>&PIPID=<%=encodedProcessItemPid%>" class="top-nav-item">Work Item</A>
<%				}
				else {     %>
					<A href="startProcessInstances.jsp" class="top-nav-item">Create Item</A>
<%				}
			}
%>
		</TD>

	<%-- Alert dialogue; display if msg parameter is available in URL --%>

		<TD>
<%		if (msg != null) {
			if (msg.equals("locked"))
				msg = "Can not perform action. Item is locked.";
			else if (msg.equals("wrongState"))
				msg = "Wrong state of work item.";
			else if (msg.equals("logon"))
				msg = "Could not log on. Check userid/password.";
			else if (msg.equals("invalid"))
				msg = "Check attribute values. At least one is invalid or a mandatory one is missing.";
%>
			<SCRIPT type="text/javascript">
			<!--
				alert('<%=msg%>');
			//-->
			</SCRIPT>
<%		}
%>
		</TD>
		
	<%-- Menu bar: userId / logout section --%>
		
		<TD class="top-navigation" align="right">
<%			if (userId == null)
                userId = "";
            else {
%>
				<B>UserID</B>&nbsp; <%=userId%>&nbsp;
				<A href="logout.jsp" class="top-nav-item"><B>Logout</B></A>
				&nbsp;&nbsp;
<%			}
	 }
     else { // show menu
%>
	<%-- Menu bar: 'Close' button (viewer window) --%>

			<A href="javascript:top.window.close()" class="top-nav-item">Close</A>
<%   }
%>
		</TD>
	</TR>
</TABLE>
