<%--  
@copyright(disclaimer) 
Licensed Materials - Property of IBM
IBM DB2 Content Manager Enterprise Edition V8  (program number 5724-B19)
IBM DB2 Content Manager Express Edition V8 (program number 5724-F73)
IBM DB2 Content Manager for z/OS V8 (program number 5697-H60)
(c ) Copyright IBM Corp. 1994,  2005. All Rights Reserved.

US Government Users Restricted Rights                                  
Use, duplication or disclosure restricted by GSA ADP Schedule        
Contract with IBM Corp.     

DISCLAIMER OF WARRANTIES :               
                                                                       
Permission is granted to copy and modify this  Sample code, and to
distribute modified versions provided that both the copyright        
notice, and this permission notice and warranty disclaimer  appear in all copies and modified  
versions. 

This software is provided "AS IS."  IBM and its Suppliers and Licensors expressly disclaim all
warranties, whether  EXPRESS OR IMPLIED,  INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE OR WARRANTY OF  NON-INFRINGEMENT.  IBM AND ITS SUPPLIERS AND
LICENSORS SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE THAT RESULT FROM USE OR
DISTRIBUTION OF THE SOFTWARE OR THE COMBINATION OF THE SOFTWARE WITH ANY OTHER CODE.
IN NO EVENT WILL IBM OR ITS SUPPLIERS  AND LICENSORS BE LIABLE FOR ANY LOST REVENUE, PROFIT OR
DATA, OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF OR INABILITY TO USE
SOFTWARE, EVEN IF IBM HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.                          
                                                                 
@endCopyright    
--%>

<%-- This JSP allow to add a content part to an item. Given a part type, mime type, and file location, submitting this page
	 causes the ImportPartServlet to import the file as a new part for this item (using a multi-part request).
--%>

<%@ page import="com.ibm.mm.beans.*,
                 com.ibm.bpe.cm.utils.Helpers"
		 language="java"
		 contentType="text/html; charset=UTF-8"
		 pageEncoding="UTF-8"
         errorPage="/error.jsp"
%>

<HTML>
<HEAD>
	<META http-equiv="Content-Type" content="text/html; charset=UTF-8">
	<META http-equiv="Expires" content="-1">
	<LINK rel="stylesheet" href="css/style.css">
	<TITLE>Quick Start Client - Import Part</TITLE>
</HEAD>
<BODY>

<%@include file="header.jsp"%>

<%  // Initialize the data management and schema beans for access to the item and its definition
    // setupDataBean also re-validates the connection
    CMBDataManagement dataBean = Helpers.setupDataBean(request, itemPid, true);
	CMBItem item = dataBean.getDataObject();
	CMBConnection connection = (CMBConnection) session.getAttribute("connection");
	CMBSchemaManagement schemaBean = connection.getSchemaManagement();

	// look up the part types defined for items of this type
	String[] partTypes = schemaBean.getEntity(item.getEntityName()).getPartTypes();

	// look up the mime types available for this library server
	CMBMimeType[] mimeTypes = schemaBean.getMimeTypeDefs();
%>

<FORM action="ImportPartServlet" enctype="multipart/form-data" method="post">
    <INPUT type="hidden" name="TKIID" value="<%=tkiidString%>">
    <INPUT type="hidden" name="PIPID" value="<%=encodedProcessItemPid%>">
    <INPUT type="hidden" name="ITEMPID" value="<%=encodedItemPid%>">

<TABLE border="0" cellpadding="0" cellspacing="0" width="100%">

	<TR>
		<TD colspan="2" class="mainseparator">Add part</TD>
	</TR>
    <TR>
    	<TD colspan="2">&nbsp;</TD>
    </TR>

	<TR>
		<TH>Part type, Mime type, and Location</TH>
		<TH>Action</TH>
	</TR>
    <TR>
    	<TD colspan="2">&nbsp;</TD>
    </TR>

	<TR>
   		<TD>
  	  		<SELECT name="partType">
<% 
				String partType;
				for(int i = 0;i < partTypes.length; i++) {
					partType = partTypes[i];
%>					<%-- ensure ICMBASE is pre-selected, if present. Alternatively, ICMBASETEXT could be preferred. --%>
					<OPTION value="<%=partType%>" <%if (partType.equals("ICMBASE")) {%>SELECTED<%}%>><%=partType%></OPTION>
<%				}
%>
 	   		</SELECT>
   		</TD>
   		<TD rowspan="2" align="left" valign="bottom">
			<A href="javascript:document.forms[0].submit()">Import</A>
   		</TD>
	</TR>

	<TR>
   		<TD colspan="2">
    		<SELECT name="mimeType">
    			<OPTION value="$EXT" selected>Defined by extension</OPTION>
<%				for(int i = 0;i < mimeTypes.length; i++) {
%>
					<OPTION value="<%=mimeTypes[i].getType()%>"><%= mimeTypes[i].getName()%></OPTION>
<%				}
%>
    		</SELECT>
   		</TD>
	</TR>
   
    <%-- IMPORTANT: the parameter of type "file" needs to be the final parameter submitted to the ImportPartServlet.
    	 The FileUploadProcessor used by the ImportPartServlet does not properly import content if this is not the case
    --%>
    
	<TR>
   		<TD colspan="2">  <%-- the parameter maxlength can be used to limit the maximum file size allowed to be imported --%>
 	  		<INPUT type="file" size="80" maxlength="10000000" name="file">
   		</TD>
	</TR>
</TABLE>
</FORM>

</BODY>
</HTML>
