<%--
@copyright(disclaimer) 
Licensed Materials - Property of IBM
IBM DB2 Content Manager Enterprise Edition V8  (program number 5724-B19)
IBM DB2 Content Manager Express Edition V8 (program number 5724-F73)
IBM DB2 Content Manager for z/OS V8 (program number 5697-H60)
(c ) Copyright IBM Corp. 1994,  2005. All Rights Reserved.

US Government Users Restricted Rights       
Use, duplication or disclosure restricted by GSA ADP Schedule
Contract with IBM Corp.

DISCLAIMER OF WARRANTIES :
                                                                       
Permission is granted to copy and modify this Sample code, and to
distribute modified versions provided that both the copyright
notice, and this permission notice and warranty disclaimer  appear in all copies and modified
versions. 

This software is provided "AS IS."  IBM and its Suppliers and Licensors expressly disclaim all
warranties, whether  EXPRESS OR IMPLIED,  INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE OR WARRANTY OF  NON-INFRINGEMENT.  IBM AND ITS SUPPLIERS AND
LICENSORS SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE THAT RESULT FROM USE OR
DISTRIBUTION OF THE SOFTWARE OR THE COMBINATION OF THE SOFTWARE WITH ANY OTHER CODE.
IN NO EVENT WILL IBM OR ITS SUPPLIERS  AND LICENSORS BE LIABLE FOR ANY LOST REVENUE, PROFIT OR
DATA, OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF OR INABILITY TO USE
SOFTWARE, EVEN IF IBM HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.                
                                                                 
@endCopyright
--%>

<%-- This is the home page of a process staff member. Loading this JSP runs a combined query against the Content Manager
     library server and the Business Process Choreographer database and displays the results in tabular form (work list).
     The contents of this worklist depends on the work list style submitted as a parameter to this JSP.
--%>

<%@ page import="java.util.List,
                 com.ibm.bpe.api.ActivityInstanceData,
                 com.ibm.bpe.api.WorkItemData,
                 com.ibm.bpe.cm.utils.Helpers,
                 com.ibm.bpe.cm.utils.ProcessData"
		 language="java"
		 pageEncoding="UTF-8"
         errorPage="/error.jsp"
%>

<jsp:useBean id="combinedQueryImpl" scope="session"	class="com.ibm.bpe.cm.utils.CombinedQueryImpl"/>

<HTML>
<HEAD>
	<META http-equiv="Content-Type" content="text/html; charset=UTF-8">
	<META http-equiv="Expires" content="-1">
	<LINK rel="stylesheet" href="css/style.css">
	<TITLE>Quick Start Client - Work List</TITLE>
</HEAD>
<BODY>

<%@include file="header.jsp"%>

<%
	Helpers.validateConnection(request);

	// we are using the same select clause for all combined queries - the worklist can display any subset of the
    // retrieved process parameter. The index values indicate the position relative to the end position of the
    // Content Manager attributes
    String selectClauseWorkflow =   "TASK.TKIID, TASK.NAME, TASK.STATE, TASK.OWNER, " +
	//								0			 1			2			3
	           						"WORK_ITEM.REASON, TASK.ACTIVATED, PROCESS_INSTANCE.NAME, " +
	//								4				   5			   6
	  		        				"PROCESS_INSTANCE.TEMPLATE_NAME, PROCESS_INSTANCE.PIID";
	//								7								 8
	
	String flowItemTypeName = "*";        // use wildcard as default to create an XPath query of the form /*[@ITEMID IN (...)]
	String flowItemTypeAttributes = "";   // default: no Content Manager attributes are shown
	String additionalAttributes = "";     //          since the flow item type is unknown in general

	// 'where' part of the BPC query: ensures that only work items are shown for which the logged-on user
	// is a POTENTIAL_OWNER. This is the standard case for the type of work list used in the sample. It can
	// be adjustet to e.g. include the READER role which would allow staff members to see work items they are not
	// allowed to claim.
	String whereClauseWorkflow =	"(TASK.STATE = "   + ActivityInstanceData.STATE_READY    + " AND " +
									 "WORK_ITEM.REASON = " + WorkItemData.REASON_POTENTIAL_OWNER + ") OR " +
									"(TASK.STATE = "  + ActivityInstanceData.STATE_CLAIMED  + " AND "  +
									 "WORK_ITEM.REASON = " + WorkItemData.REASON_OWNER + ")";
					     
	String orderByClauseWorkflow = "TASK.NAME";  // ensure work items are grouped according to the activity they belong to
									   // orderByClauseWorkflow - ACTIVITY.STARTED may seem
		      					       // like a good option but it makes work items the user is currently working move down
		      					       // the list as new work items come in - not desired from a usability perspective
	
	// Default column names and sortOrder
    String[] columnNames = new String[]{ "Task", "Activated", "Work Item State" };
    int[] sortOrder      = new int[]{    2,		 6,           3};
    int posOfStateAttr   = 2;
    
    // If a specific work list style has been specified in the URL that opened this page, replace the default values
    // by the specific ones (as defined in ProcessData.jsp)
	ProcessData.WorkListQuery wlq = ProcessData.getWorkListQuery(wlId);
	if (wlq != null) {
    	flowItemTypeName = wlq.flowItemTypeName;
    	flowItemTypeAttributes = wlq.flowItemTypeAttributes;
    	additionalAttributes = wlq.additionalAttributes;
    	columnNames = wlq.columnNames;
    	sortOrder = wlq.sortOrder;
    	posOfStateAttr = wlq.posOfStateAttr;
    }
    
    int colNum = sortOrder.length - 1;
    
    // Filter the items of interest with those referred to by process instances to obtain the subset of interest    
    String contentXPathFilter = "/" + flowItemTypeName + "[%ITEM_LIST_PREDICATE%]" ;
			  		        
	// Run the combined query that defines the contents of the work list
	List result = combinedQueryImpl.combinedQuery(
   			selectClauseWorkflow,			// The workflowElements and contentElements
			flowItemTypeName,				// define the attributes to be displayed on the worklist.
			flowItemTypeAttributes,	    	// flowItemTypeAttributes,
			additionalAttributes,			// additionalAttributes,
      		whereClauseWorkflow,			// whereClauseWorkflow,
	      	contentXPathFilter,				// contentXPathFilter,
			null);							// orderByClause  
%>

	<%-- Display the work list --%>

	<TABLE border="0" cellpadding="0" cellspacing="0" width="100%">

		<TR>
			<TD colspan="<%=colNum + 2%>" class="mainseparator">Worklist</TD>
		</TR>
<%
  	if (result != null && result.size() > 0) {		// any work items to display ?
%>
  		<TR>
<%	    	// print column headers as defined by columnName[]
			for (int j = 0; j <= colNum; j++) { %>
    		    <TH><%=columnNames[j]%></TH>
<%  		}
%>
    			<TH>Action</TH>
		</TR>
<%
			// print rows each representing a work item
   			int state = 0;
   			int counter = 0;
   			String styleClass;
   			List resultRow = null;
   			
   			// iterate over rows
			for (int i = 0; i < result.size(); i++) {
				// use alternate background for adjacent rows to improve readability
				styleClass = ( counter % 2 == 0 )? "even" : "odd" ;
				counter++ ;
%>  			
   				<TR class="<%=styleClass%>">
<%
				    Object resultValue;
					resultRow = (List)(result.get(i));

					// iterate over columns
					for (int j = 0; j <= colNum; j++) {

						// look up result attribute at the current position of the result list
					    if (j == posOfStateAttr) { // ACTIVITY.STATE attribute -> translate into comprehensive state name
							state = (new Integer((resultRow.get(2)).toString())).intValue();
							resultValue = (state == ActivityInstanceData.STATE_CLAIMED) ? "Fetched" :
			   					          (state == ActivityInstanceData.STATE_READY) ? "Ready" : "Unknown";
				    	}
				    	else {
				    		resultValue = resultRow.get(sortOrder[j]);
					        if (resultValue == null) resultValue = "-";  // use '-' as marker for empty table cells
					    }
%>
						<TD><%=resultValue.toString()%></TD>
<%					} // for all columns

					// look up activity instance ID at the current position of the result list
					tkiidString = (resultRow.get(0)).toString();   // ((OID)result).toString;
						
					// activities with state READY can be fetched (claimed)
					if (state == ActivityInstanceData.STATE_READY) {
%>		
						<TD><A href="showWorkItem.jsp?TKIID=<%=tkiidString%>&CLAIM=true">Fetch</A></TD>
<%					}
					// activities with state FETCHED (claimed) can be opened
					else if (state == ActivityInstanceData.STATE_CLAIMED) {
%>					
						<TD><A href="showWorkItem.jsp?TKIID=<%=tkiidString%>">Open</A></TD>
<%					}
%>
				</TR>
<%			} // for all rows
		} // if result.size() > 0
%>
	</TABLE>

</BODY>
</HTML>
