<%--
@copyright(disclaimer) 
Licensed Materials - Property of IBM
IBM DB2 Content Manager Enterprise Edition V8  (program number 5724-B19)
IBM DB2 Content Manager Express Edition V8 (program number 5724-F73)
IBM DB2 Content Manager for z/OS V8 (program number 5697-H60)
(c ) Copyright IBM Corp. 1994,  2005. All Rights Reserved.

US Government Users Restricted Rights                                  
Use, duplication or disclosure restricted by GSA ADP Schedule          
Contract with IBM Corp.     

DISCLAIMER OF WARRANTIES :                                  
                                                                       
Permission is granted to copy and modify this  Sample code, and to  
distribute modified versions provided that both the copyright
notice, and this permission notice and warranty disclaimer  appear in all copies and modified
versions. 

This software is provided "AS IS."  IBM and its Suppliers and Licensors expressly disclaim all
warranties, whether  EXPRESS OR IMPLIED,  INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE OR WARRANTY OF  NON-INFRINGEMENT.  IBM AND ITS SUPPLIERS AND
LICENSORS SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE THAT RESULT FROM USE OR
DISTRIBUTION OF THE SOFTWARE OR THE COMBINATION OF THE SOFTWARE WITH ANY OTHER CODE.
IN NO EVENT WILL IBM OR ITS SUPPLIERS  AND LICENSORS BE LIABLE FOR ANY LOST REVENUE, PROFIT OR
DATA, OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF OR INABILITY TO USE
SOFTWARE, EVEN IF IBM HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.                          
                                                                 
@endCopyright
--%>

<%-- This JSP illustrates the different ways to initiate processes in a CM/WPS environment. I contains three sections
     that simulate different options for starting the sample process.
     1. The first section titled 'Create documents' simulates the manual creation of documents.
        Clicking 'create' displays an empty attribute value diaolgue (Attribute Details page) for the selected item type.
        Clicking 'save' on the 'Attribute Details' page triggers the creation of a process instance based on
        Content Event Handling (see the Quick Start Manual for details)
     2. The second section titled 'Import predefined documents' simulates automatic ingestion of a scanned document.
        Clicking 'Create' switches to the Attribute Details page and displays predefined attribute values of a sample
        document. By clicking 'Save' this document is created in Content Manager and parts may be added to it.
        As with section 1 the 'Content Event Handling' mechanism triggers the creation of process instances for items of type XYZ_ClaimFolder
     3. The third section titled 'Create process instance for existing items' simulates an application that explicitly
        creates process instances. This replaces the Process Starter Application Client used with the integration sample
        of Content Manager 8.3.
        Clicking 'Submit' launches a Content Manager Query. The StartProcessInstancesServlet contains the code that creates
        a process instance for each element of the result list. A mailroom user can refine the query by entering a
        condition into the input field.
--%>

<%@ page import="com.ibm.bpe.cm.utils.Helpers"
		 language="java"
		 pageEncoding="UTF-8"
         errorPage="/error.jsp"
%>

<HTML>
<HEAD>
	<META http-equiv="Content-Type" content="text/html; charset=UTF-8">
	<META http-equiv="Expires" content="-1">
	<LINK rel="stylesheet" href="css/style.css">
	<TITLE>Quick Start Client - Start Process Instances</TITLE>
</HEAD>
<BODY>

<%@include file="header.jsp"%>

<%	
	Helpers.validateConnection(request);

	// store the process name in a session attribute;
	String processName = (String)session.getAttribute("process");
	if (processName == null) {
		processName = request.getParameter("processName");
		session.setAttribute("process", processName);
	}
%>

<TABLE border="0" cellpadding="0" cellspacing="0" width="100%">

	<%-- **************************** SECTION 1: Create documents ******************************** --%>

	<TR>
		<TD colspan="2" class="mainseparator">Create documents based on blank forms</TD>
	</TR>
	<TR><TD>&nbsp;</TD></TR>

	<TR>
		<TD><A href="updateAttributes?mode=nocreate&entityName=XYZ_InsPolicy">Insurance Policy</A></TD>
	</TR>
	<TR>
		<TD><A href="updateAttributes?mode=nocreate&entityName=XYZ_ClaimForm">Claim Form</A></TD>
	</TR>
	<TR>
		<TD><A href="updateAttributes?mode=nocreate&entityName=XYZ_AdjReport">Adjuster Report</A></TD>
	</TR>
	<TR>
		<TD><A href="updateAttributes?mode=nocreate&entityName=XYZ_PolReport">Police Report</A></TD>
	</TR>
	<TR><TD>&nbsp;</TD></TR>

	<%-- **************************** SECTION 2: Import predefined documents ******************************** --%>

	<TR>
		<TD colspan="2" class="mainseparator">Create documents based on predefined form data</TD>
	</TR>
	<TR><TD>&nbsp;</TD></TR>

	<TR>
		<TD colspan="2"><B>Claim Forms</B></TD>
	</TR>

	<TR>
	<TD>
	<FORM action="UpdateAttributesServlet" method="POST">
		<INPUT type="hidden" name="mode" value="nocreate">
		<INPUT type="hidden" name="entityName" value="XYZ_ClaimForm">
		<INPUT type="hidden" name="TKIID" value="">	
		<INPUT type="hidden" name="PIPID" value="">	
		<INPUT type="hidden" name="ITEMPID" value="">	
		<INPUT type="hidden" name="attr.1.XYZ_ClaimFName" value="Mary">	
		<INPUT type="hidden" name="attr.1.XYZ_ClaimLName" value="Twain">	
		<INPUT type="hidden" name="attr.2.XYZ_DriversLic" value="B54673210">	
		<INPUT type="hidden" name="attr.7.XYZ_IncDate" value="2005-09-09">	
		<INPUT type="hidden" name="attr.1.XYZ_InsrdFName" value="Gregory">	
		<INPUT type="hidden" name="attr.1.XYZ_InsrdLName" value="Twain">	
		<INPUT type="hidden" name="attr.2.XYZ_PolicyNum" value="10452136412">	
		<INPUT type="hidden" name="attr.2.XYZ_ClaimNumber" value="3-742019">
		<A href="javascript:document.forms[0].submit()">Mary Twain</A> 
	</FORM> 
	</TD>
	</TR>

	<TR>
	<TD>
	<FORM action="UpdateAttributesServlet" method="POST">
		<INPUT type="hidden" name="mode" value="nocreate">
		<INPUT type="hidden" name="entityName" value="XYZ_ClaimForm">
		<INPUT type="hidden" name="TKIID" value="">	
		<INPUT type="hidden" name="PIPID" value="">	
		<INPUT type="hidden" name="ITEMPID" value="">	
		<INPUT type="hidden" name="attr.1.XYZ_ClaimFName" value="Alexander">	
		<INPUT type="hidden" name="attr.1.XYZ_ClaimLName" value="Churchill">	
		<INPUT type="hidden" name="attr.2.XYZ_DriversLic" value="B23456789">	
		<INPUT type="hidden" name="attr.7.XYZ_IncDate" value="2005-09-06">	
		<INPUT type="hidden" name="attr.1.XYZ_InsrdFName" value="Jessica">	
		<INPUT type="hidden" name="attr.1.XYZ_InsrdLName" value="Fitzgerald">	
		<INPUT type="hidden" name="attr.2.XYZ_PolicyNum" value="10315975308">	
		<INPUT type="hidden" name="attr.2.XYZ_ClaimNumber" value="3-501699">
		<A href="javascript:document.forms[1].submit()">Alexander Churchill</A> 
	</FORM> 
	</TD>
	</TR>
	<TR><TD>&nbsp;</TD></TR>

	<TR>
		<TD colspan="2"><B>Adjuster Reports</B></TD>
	</TR>
	
	<TR>
	<TD>
	<FORM action="UpdateAttributesServlet" method="POST">
		<INPUT type="hidden" name="mode" value="nocreate">
		<INPUT type="hidden" name="entityName" value="XYZ_AdjReport">
		<INPUT type="hidden" name="TKIID" value="">	
		<INPUT type="hidden" name="PIPID" value="">	
		<INPUT type="hidden" name="ITEMPID" value="">	
		<INPUT type="hidden" name="attr.7.XYZ_AdjustDate" value="2005-09-10">	
		<INPUT type="hidden" name="attr.1.XYZ_AdjustFName" value="Mike">	
		<INPUT type="hidden" name="attr.1.XYZ_AdjustLName" value="Reed">	
		<INPUT type="hidden" name="attr.1.XYZ_ClaimFName" value="Mary">	
		<INPUT type="hidden" name="attr.1.XYZ_ClaimLName" value="Twain">	
		<INPUT type="hidden" name="attr.7.XYZ_IncDate" value="2005-09-09">	
		<INPUT type="hidden" name="attr.2.XYZ_LicPlate" value="4IBM134">	
		<INPUT type="hidden" name="attr.2.XYZ_PolicyNum" value="10452136412">	
		<INPUT type="hidden" name="attr.2.XYZ_ClaimNumber" value="3-742019">
		<INPUT type="hidden" name="attr.6.XYZ_ClaimAmount" value="1000">
		<A href="javascript:document.forms[2].submit()">Adjuster Report for Mary Twain's case</A> 
	</FORM> 
	</TD>
	</TR>

	<TR>
	<TD>
	<FORM action="UpdateAttributesServlet" method="POST">
		<INPUT type="hidden" name="mode" value="nocreate">
		<INPUT type="hidden" name="entityName" value="XYZ_AdjReport">
		<INPUT type="hidden" name="TKIID" value="">	
		<INPUT type="hidden" name="PIPID" value="">	
		<INPUT type="hidden" name="ITEMPID" value="">	
		<INPUT type="hidden" name="attr.7.XYZ_AdjustDate" value="2005-09-08">	
		<INPUT type="hidden" name="attr.1.XYZ_AdjustFName" value="Bob">	
		<INPUT type="hidden" name="attr.1.XYZ_AdjustLName" value="McLaren">	
		<INPUT type="hidden" name="attr.1.XYZ_ClaimFName" value="Robert">	
		<INPUT type="hidden" name="attr.1.XYZ_ClaimLName" value="Fitzgerald">	
		<INPUT type="hidden" name="attr.7.XYZ_IncDate" value="2005-09-06">	
		<INPUT type="hidden" name="attr.2.XYZ_LicPlate" value="4IBM134">	
		<INPUT type="hidden" name="attr.2.XYZ_PolicyNum" value="10452136412">	
		<INPUT type="hidden" name="attr.2.XYZ_ClaimNumber" value="3-501699">
		<INPUT type="hidden" name="attr.6.XYZ_ClaimAmount" value="50000">
		<A href="javascript:document.forms[3].submit()">Adjuster Report for Alexander Churchill's case</A> 
	</FORM> 
	</TD>
	</TR>
	<TR><TD>&nbsp;</TD></TR>

	<TR>
		<TD colspan="2"><B>Police Reports</B></TD>
	</TR>


	<TR>
	<TD>
	<FORM action="UpdateAttributesServlet" method="POST">
		<INPUT type="hidden" name="mode" value="nocreate">
		<INPUT type="hidden" name="entityName" value="XYZ_PolReport">
		<INPUT type="hidden" name="TKIID" value="">	
		<INPUT type="hidden" name="PIPID" value="">	
		<INPUT type="hidden" name="ITEMPID" value="">	
		<INPUT type="hidden" name="attr.1048.XYZ_VictimInfo.intAttr.0.2.XYZ_LicPlate" value="4IBM134">	
		<INPUT type="hidden" name="attr.1048.XYZ_VictimInfo.intAttr.1.2.XYZ_DriversLic" value="B54673210">	
		<INPUT type="hidden" name="attr.2.XYZ_ReportNum" value="09092005-22">	
		<INPUT type="hidden" name="attr.7.XYZ_IncDate" value="2005-09-09">	
		<INPUT type="hidden" name="attr.2.XYZ_ClaimNumber" value="3-742019">
		<A href="javascript:document.forms[4].submit()">Police Report for Mary Twain's case</a>
	</FORM> 
	</TD>
	</TR>

	<TR>
	<TD>
	<FORM action="UpdateAttributesServlet" method="POST">
		<INPUT type="hidden" name="mode" value="nocreate">
		<INPUT type="hidden" name="entityName" value="XYZ_PolReport">
		<INPUT type="hidden" name="TKIID" value="">	
		<INPUT type="hidden" name="PIPID" value="">	
		<INPUT type="hidden" name="ITEMPID" value="">	
		<INPUT type="hidden" name="attr.1048.XYZ_VictimInfo.intAttr.0.2.XYZ_LicPlate" value="1ABC089">	
		<INPUT type="hidden" name="attr.1048.XYZ_VictimInfo.intAttr.1.2.XYZ_DriversLic" value="B98755678">	
		<INPUT type="hidden" name="attr.2.XYZ_ReportNum" value="09062005-21">	
		<INPUT type="hidden" name="attr.7.XYZ_IncDate" value="2005-09-06">	
		<INPUT type="hidden" name="attr.2.XYZ_ClaimNumber" value="3-501699">
		<A href="javascript:document.forms[5].submit()">Police Report for Alexander Churchill's case</a>
	</FORM> 
	</TD>
	</TR>

	<TR><TD>&nbsp;</TD></TR>

	<%-- **************************** SECTION 3: Create process instances for existing items ********************* --%>

	<TR>
		<TD colspan="2" class="mainseparator">Create process instances for existing items</TD>
	</TR>
	<TR><TD colspan="2">&nbsp;</TD></TR>
	
		<TR>
		<TD colspan="2" >
			<FORM action="StartProcessInstancesServlet?processName=<%=processName%>" method="POST">
				Content Manager Query <INPUT type="text" name="query" size="80" value="/XYZ_ClaimFolder">
				<A href="javascript:document.forms[6].submit()">Submit</A> 
			</FORM>
		</TD>
	</TR>

	<TR>
		<TD colspan="2" >
<%
		String numHits = request.getParameter("numHits");
		if (numHits != null) {
%>
			<%=numHits%> process instances created.
<%
		}
%>
		</TD>
	</TR>

</table>
</body>
</html>
